<?php
    // Initialize any vars we may have received via POST
    $srslide_api_key              = (!empty($_POST['srslide_api_key'])) ? $_POST['srslide_api_key'] : '';
    $srslide_pid                  = (!empty($_POST['srslide_pid'])) ? $_POST['srslide_pid'] : '';
    $srslide_cat_as_chan          = (!empty($_POST['srslide_cat_as_chan']));
    $srslide_header_text          = (!empty($_POST['srslide_header_text'])) ? $_POST['srslide_header_text'] : '';
    $srslide_register_hidden      = (!empty($_POST['srslide_register_hidden']));
    $srslide_validate_hidden      = (!empty($_POST['srslide_validate_hidden']));
    $srslide_save_hidden          = (!empty($_POST['srslide_save_hidden']));
    $srslide_show_logo            = (!empty($_POST['srslide_show_logo']));
    $srslide_sr_login             = (!empty($_POST['srslide_sr_login'])) ? $_POST['srslide_sr_login'] : '';
    $srslide_sr_pass              = (!empty($_POST['srslide_sr_pass'])) ? $_POST['srslide_sr_pass'] : '';
    $srslide_style_element_bottom = (!empty($_POST['srslide_style_element_bottom'])) ? $_POST['srslide_style_element_bottom'] : '';
    $srslide_use_pages            = (!empty($_POST['srslide_use_pages']));
    $srslide_css_option           = (!empty($_POST['srslide_css_option'])) ? $_POST['srslide_css_option'] : 1;
    $srslide_css_url              = (!empty($_POST['srslide_css_url'])) ? $_POST['srslide_css_url'] : '';


    // Is the publisher a registered SimpleReach user
    $sr_is_registered = get_option('srslide_registered');

    // Set up debug info and support link
    $debug_info = create_debug_info();
    $supportLink = '<a href="https://www.simplereach.com/contact?r=support&e='.$srslide_sr_login.'&debug_info='.urlencode($debug_info).'">SimpleReach support</a>';

    if ($srslide_validate_hidden) {
        $encoded_params = array();
        $encoded_params['api_key'] = $srslide_api_key;
        $encoded_params['pid'] = $srslide_pid;

        // Curl call for validation
        $url = 'https://www.simplereach.com/publisher/wp_validate';
        $response = srslide_post_url($url, $encoded_params);

        // Decode the JSON
        $resp = json_decode($response);

        if (!empty($resp->success)) {
            // Save the PID and the API Key to Wordpress
            update_option('srslide_pid', $resp->success);
            update_option('srslide_api_key', $resp->api_key);
            update_option('srslide_registered', true);

            print '<div id="message" class="success below-h2"><p>';
            print _e('Your credentials have been validated.  <a href="'. str_replace("%7E", "~", $_SERVER['REQUEST_URI']) . '">Click here</a> to continue ....', 'srslide');
            print '</p></div>';
        } else {
            print '<div id="message" class="error below-h2"><p>';
            print _e('There was an error processing your credentials.  Please try again.', 'srslide');
            print '</p></div>';
        }


    } else if ($srslide_save_hidden) {
        $errors = array();

        // Set the show logo option
        update_option('srslide_show_logo', $srslide_show_logo);

        // Set the recommend pages option
        update_option('srslide_use_pages', $srslide_use_pages);

        // Set the option deciding whether categories should be used as channels
        update_option('srslide_cat_as_chan', $srslide_cat_as_chan);

        // Store bottom offset locally
        update_option('srslide_style_element_bottom', $srslide_style_element_bottom);

        $header_length = strlen($srslide_header_text);
        if ($header_length < 1 or $header_length > 30) {
            array_push($errors, __("Header text cannot be more than 30 characters.",'srslide'));
        } else {
            update_option('srslide_header_text', strtoupper($srslide_header_text));
        }

        $api_key_length = strlen($srslide_api_key);
        if ($api_key_length != 32) {
            array_push($errors, __("API Key should be 32 characters. Please double check your entry.",'srslide'));
        } else {
            update_option('srslide_api_key', $srslide_api_key);
        }

        $srslide_pid_length = strlen($_POST['srslide_pid']);
        if ($srslide_pid_length != 24) {
            array_push($errors, __("PID should be 24 characters. Please double check your entry.",'srslide'));
        } else {
            update_option('srslide_pid', $_POST['srslide_pid']);
        }


	$url_error = false;
	if ($srslide_css_option != 2) {
		$srslide_css_url = '';
		update_option('srslide_css_option',1);
		update_option('srslide_css_url', '');
	}
	else {
		if (function_exists('filter_var')) {
			if (!filter_var($srslide_css_url,FILTER_VALIDATE_URL)) {
				array_push($errors, __("You selected a custom CSS URL, but the URL you entered is blank or invalid.",'srslide'));
				$url_error = true;
			}
		}
		else {
			$srslide_css_url = str_replace(array('"',"'",'<'),array(''),$srslide_css_url);
		}
		if (!$url_error) {
			update_option('srslide_css_option',2);
			update_option('srslide_css_url', $srslide_css_url);
		}
	}


        // Convert the style settings into a hash and save it
        // TODO Write comparison function to if styles that need to be sent to CDN haven't been changed. Skip CURL if there was no change
        update_option('srslide_styles', create_style_hash($_POST));

        $style_error = update_slide_styles();
        if ($style_error != "OK") {
            array_push($errors, $style_error);
        }

        // Save if we are error free or print the errors
        if (count($errors) == 0) {
          ?>
          <div class="updated"><p><strong><?php _e('Options saved. If you shifted The Slide position or adjusted the link color, it could take up to 15 minutes for your changes to take effect.', 'srslide'); ?></strong></p></div>
          <?php
        } else {
          ?>
          <div class="error"><p><strong><?php _e('You have the following errors:', 'srslide'); ?></strong></p></div>

          <?php
              foreach ($errors as $i => $value) {
                  ?>
                  <div class="error"><p style='margin-left:10px;'><strong><?php echo $value; ?></strong></p></div>
                  <?php
              }
        }

    /*
     * Part of the conditional for handling a registration
     */
    } else if ($srslide_register_hidden) {

        // Setup the encoded params from the $_POST
        // foreach ($_POST as $name => $value) {
        //     // Only pass vars that start with srslide_sr
        //     if (preg_match('/^srslide_sr/', $name)) {
        //         $encoded_params[urlencode($name)] = urlencode($value);
        //     }
        // }
        $errors = array();

        // Validations
        if (!srslide_validate_login($srslide_sr_login)) {
            $errors[] = 'Invalid login';
        } else {
            $encoded_params['srslide_sr_login'] = $srslide_sr_login;
        }

        if (!srslide_validate_password($srslide_sr_pass)) {
            $errors[] = 'Invalid password';
        } else {
            $encoded_params['srslide_sr_pass'] = $srslide_sr_pass;
        }

        if (count($errors)) {
            $resp = new StdClass;
            $resp->success = FALSE;
            $resp->error = array_shift($errors);
        } else {

            // Get the blog name
            $encoded_params['account_name'] = urlencode(get_option('blogname'));

            // Get the site URL
            $encoded_params['website'] = urlencode(get_option('siteurl'));
            $encoded_params['ts'] = (int)gmdate('U');

            // Curl call for registration
            $url = 'https://www.simplereach.com/publisher/wp_create';
            $response = srslide_post_url($url, $encoded_params);

            // Decode the JSON
            $resp = json_decode($response);
        }


        if (!empty($resp->{'success'})) {

            // Save the PID and the API Key to Wordpress
            update_option('srslide_pid',$resp->{'success'});
            if ($resp->{'api_key'}) {
                update_option('srslide_api_key',$resp->{'api_key'});
            }

            // Set some defaults only now that we have a registration
            set_srslide_defaults($_POST);
            ?>
                <div id="message" class="updated below-h2"><p>
                    <?php _e("Congrats! You're all set to go. Please be patient, it can take up to 15 mins to get things started. Thanks.", 'srslide') ?>
                </p></div>
            <?php
        } else {
            ?>
                <div id="message" class="error below-h2"><p>
            <?php
                _e("We were not able to register you: ", 'srslide');
                if ($resp->{'error'} == 'Invalid Domain') {
                    _e("This domain has already been registered. Please contact $supportLink if you believe you have received this message in error.", 'srslide');
                } else if ($resp->{'error'} == 'Invalid login') {
                    _e("Your login name must be a valid email address.  Please try again.");
                } else if ($resp->{'error'} == 'Invalid password') {
                    _e("Your password must be at least 6 characters long not more than 100 alphanumeric characters long.  Please try again.");
                } else if ($resp->{'error'} == 'Incorrect Timestamp') {
                    _e("There was an error while you were attempting to register. Please try again or contact $supportLink if you believe you have received this message in error.", 'srslide');
                } else if ($resp->{'error'} == 'Invalid Password') {
                    _e("The user name that you are attempting to register with already exists, but the password you entered was incorrect. Please try again or contact $supportLink if you believe you have received this message in error.", 'srslide');
                } else if ($resp->{'error'} == 'SimpleReach Website') {
                    if ($resp->{'error_msg'}) {
                        $debug_info .= $resp->{'error_msg'};
                    }
                    $srslide_sr_login = (!empty($_POST['srslide_sr_login'])) ? $_POST['srslide_sr_login'] : 'none';
                    _e("The SimpleReach Website has experienced an error, please click $supportLink to submit a ticket.");
                } else if ($resp->{'error'} == 'Invalid Website') {
                    _e("The website that you attempting to register with is invalid. Please click $supportLink for futher assistance.", 'srslide');
                } else {
                    _e("An unknown error has been encountered. Please try again or contact $supportLink.", 'srslide');
                }
            ?>
                </p></div>
            <?php
            update_option('srslide_registered',false);
        }
    }

?>

<div class="srslide_admin">
    <?php
        echo "<h2>" . __('The Slide by SimpleReach', 'srslide') . "</h2>";

        if ($sr_is_registered) {
            // Part of our normal page display
            $srpid = get_option('srslide_pid');
            $srlogin = get_option('srslide_sr_login');
            $srslide_header_text = get_option('srslide_header_text');
            $srslide_style = get_option('srslide_styles');
            $srslide_api_key = get_option('srslide_api_key');

            $slide_show_logo = 'CHECKED=CHECKED';
            if (get_option('srslide_show_logo') == false) {
              $slide_show_logo = '';
            }

            $slide_use_pages = 'CHECKED=CHECKED';
            if (get_option('srslide_use_pages') == false) {
              $slide_use_pages = '';
            }

            $slide_cat_as_chan = 'CHECKED=CHECKED';
            if (get_option('srslide_cat_as_chan') == false) {
              $slide_cat_as_chan = '';
            }

	    $srslide_css_option = get_option('srslide_css_option');
	    $srslide_css_url = get_option('srslide_css_url');
    ?>

        <div class="overview">
            <p>
                <?php _e("Use your email/password to LOG-IN to ", 'srslide'); ?><a href="https://www.simplereach.com">simplereach.com</a> <?php _e(" to access your analytics/reporting dashboard", 'srslide'); ?>.
            </p>
            <p>
                <?php _e("If you're a developer, you can fully customize the style and functionality of The Slide through our ", 'srslide'); ?> <a href="https://www.simplereach.com/docs/publisher/overview"><?php _e("documentation", 'srslide'); ?></a>.
            </p>
            <p>
                <?php _e("If you have any questions, please don't hesitate to contact $supportLink!", 'srslide'); ?>
            </p>
        </div>

      <hr />

        <?php echo "<h3>" . __('Display Settings', 'srslide') . "</h3>"; ?>

        <div id="srslide_controls">
            <form name="srslide_form" method="post" action="<?php echo str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>">

                <input type="hidden" name="srslide_save_hidden" value="Y">

                <table border="2">
                    <tr>
                        <td valign="top" style='padding-top:4px;'>
                            <?php _e("Edit Header (Max 30 char):", 'srslide'); ?>
                        </td>
                        <td colspan="2">
                                <input type="textbox" name="srslide_header_text" value='<?php echo $srslide_header_text; ?>' /><br />
                                <span class="srslide_minitext"><?php _e("All letters will be uppercase.", 'srslide'); ?> &nbsp; (<?php _e("Default: RECOMMENDED FOR YOU", 'srslide'); ?>)</span>
                        </td>
                    </tr>
                    <tr>
                        <td colspan="3">
                            <div>
                                <div class="link_color_label"><?php _e("Link Color:", 'srslide'); ?></div>
                                <?php
                                    $srslide_default_link_colors = array('#FE3F10', '#3B5998', '#CC0000');
                                    foreach ($srslide_default_link_colors as $color) {
					                    $colorChecked = ($srslide_style['link']['color'] == $color) ? 'CHECKED' : '';
                                ?>
                                    <div class="link_color_selector">
                                        <input type="radio" name="srslide_style_link_color" value="<?php echo $color; ?>" <?php echo $colorChecked; ?>>
                                        <div style="background-color:<?php echo $color; ?>;"></div>
                                    </div>
                                <?php
                                    }
                                ?>
                                    <input class="custom_color" type="radio" name="srslide_style_link_color" value="other" <?php if (!in_array($srslide_style['link']['color'],$srslide_default_link_colors)) { echo "CHECKED"; } ?>> &nbsp;
					<input type="textbox" name="srslide_style_link_color_text" value='<?php if (!in_array($srslide_style['link']['color'],$srslide_default_link_colors)) { echo "{$srslide_style['link']['color']}"; } ?>' />
                                    <div class="custom_color_label" style='float:left;'><?php _e("hex code ", 'srslide'); ?><br /><span class="srslide_minitext"><?php _e("(eg #FE3F10):", 'srslide'); ?></span></div>
                                </div>
                            </div>
                        </td>
                    </tr>

                    <tr>
                        <td colspan='3'>
                            <span><?php _e("Shift The Slide up by: ", 'srslide'); ?></span>
                            <select name='srslide_style_element_bottom'>
				<?php
					$shiftUpValues = array('0', '30', '40', '50', '60');
					foreach ($shiftUpValues as $shiftUpValue) {
						$shiftUpValueSelected = ($srslide_style['element']['bottom'] == $shiftUpValue) ? 'SELECTED' : '';
						print '<option value="'.$shiftUpValue.'" '.$shiftUpValueSelected .'>'.$shiftUpValue.'px</option>';
					}
				?>
                            </select>
                        </td>
                    </tr>

                    <tr>
                        <td colspan="3">
                                <input type="checkbox" name="srslide_use_pages" <?php echo $slide_use_pages; ?> />
                                <?php _e("Also show The Slide on", 'srslide'); ?> <em><?php _e("Pages", 'srslide'); ?></em><br />
                                <span class="srslide_minitext" style='margin-left:18px;'>
                                    <?php _e("Default setting is to show The Slide only on ", 'srslide'); ?>
                                    <em><?php _e("Posts", 'srslide'); ?></em>
                                </span>
                        </td>
                    </tr>

                    <tr>
                        <td colspan="3">
                                <input type="checkbox" name="srslide_cat_as_chan" <?php echo $slide_cat_as_chan; ?> />
                                <?php _e("Categorize Recommendations", 'srslide'); ?><br />
                                <span class="srslide_minitext" style='margin-left:18px;'>
                                    <?php _e("Only recommend posts in the same category/channel", 'srslide'); ?>
                                </span>
                        </td>
                    </tr>

<?php
if (0) {
?>
                    <tr>
                        <td colspan="3">
                            <input type="checkbox" name="srslide_show_logo" <?php echo $slide_show_logo; ?> />
                            <span><?php _e("Display The Slide logo (increases engagement)", 'srslide'); ?></span>
                        </td>
                    </tr>
<?php
}
?>
                   <tr>
                        <td colspan="3">
                               Stylesheet:&nbsp;
                                  <input type="radio" name="srslide_css_option" value="1" <?php echo ($srslide_css_option != 2) ? 'Checked' : ''; ?>>&nbsp;Default&nbsp;&nbsp;&nbsp;&nbsp;
				  <input type="radio" name="srslide_css_option" value="2" <?php echo ($srslide_css_option == 2) ? 'Checked' : ''; ?>>&nbsp;Custom URL:&nbsp;
				<input type="textbox" name="srslide_css_url" size="30" value="<?php echo ($srslide_css_option == 2) ? $srslide_css_url : ''; ?>">
                        </td>
                    </tr>

                </table>

                <input type="submit" name="Submit" value="<?php _e('Save', 'srslide'); ?>" />
                <hr />

                <?php echo "<h3>" . __('Account Settings', 'srslide') . "</h3>"; ?>

                    <table>
                    <tr>
                        <td valign="top" style="padding-top: 4px">
                            <?php _e("API Key:", 'srslide'); ?>
                        </td>
                        <td colspan="2">
                                <input type="textbox" name="srslide_api_key" value="<?php echo $srslide_api_key; ?>" /><br />
                                <span class="srslide_minitext"><?php _e("Warning: Do not change unless you know what you are doing.", 'srslide'); ?></span>
                        </td>
                    </tr>

                    <tr>
                        <td valign="top" style="padding-top: 4px">
                            <?php _e("Publisher ID (PID):", 'srslide'); ?>
                        </td>
                        <td colspan="2">
                                <input type="textbox" name="srslide_pid" value="<?php echo $srpid; ?>" /><br />
                                <span class="srslide_minitext"><?php _e("Warning: Do not change unless instructed by SimpleReach.", 'srslide'); ?></span>
                        </td>
                    </tr>
                </table>

            <input type="submit" name="Submit" value="<?php _e('Save', 'srslide'); ?>" />
            </form>
        </div>

        <div id="srslide_example">
            <img src="http://d8rk54i4mohrb.cloudfront.net/images/plugins/wp_slide_example.png">
        </div>

    <?php
        } else {
            $regOnHold = 1;
            if ($regOnHold) {
    ?>
    <style type="text/css">
        .myHidden { display: none; }
        .myShown  { display: block; }
    </style>
    <script type="text/javascript">
        window.onload = function() {
            document.getElementById('showForm').onclick = function() {
                document.getElementById('srslide_form').className = (document.getElementById('srslide_form').className == 'myShown') ? 'myHidden' : 'myShown';
                return false;
            }
        }
    </script>
        <div id="srslide_register">
        <p><strong><?php _e("We are currently in private beta. <a href=\"https://www.simplereach.com/contact#reach-out\">Contact us</a> to apply.", 'srslide') ?></strong></p>
        If you already have credentials, click <a href="#" id="showForm">here</a>.
        <form class="myHidden" id="srslide_form" name="srslide_form" method="post" action="<?php echo str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>">
          <input type="hidden" name="srslide_validate_hidden" value="Y">

                    <table>
                    <tr>
                        <td valign="top" style="padding-top: 4px">
                            <?php _e("API Key:", 'srslide'); ?>
                        </td>
                        <td colspan="2">
                                <input type="textbox" name="srslide_api_key" value="<?php echo $srslide_api_key; ?>" /><br />
                                <span class="srslide_minitext"><?php _e("Warning: Do not change unless you know what you are doing.", 'srslide'); ?></span>
                        </td>
                    </tr>

                    <tr>
                        <td valign="top" style="padding-top: 4px">
                            <?php _e("Publisher ID (PID):", 'srslide'); ?>
                        </td>
                        <td colspan="2">
                                <input type="textbox" name="srslide_pid" value="<?php echo $srslide_pid; ?>" /><br />
                                <span class="srslide_minitext"><?php _e("Warning: Do not change unless instructed by SimpleReach.", 'srslide'); ?></span>
                        </td>
                    </tr>
                </table>

            <input type="submit" name="Submit" value="<?php _e('Save', 'srslide'); ?>" />

        </form>
	</div>

    <?php
            } else {
                $slide_show_logo = 'CHECKED=CHECKED';
    ?>

	<div id="srslide_register">
        <p><strong><?php _e("Register for a SimpleReach account. If you have already registered at simplereach.com, enter your login information below.", 'srslide') ?></strong></p>
        <form name="srslide_form" method="post" action="<?php echo str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>">
          <input type="hidden" name="srslide_register_hidden" value="Y">

            <table cellspacing="8">
              <tr>
                <td class="label"><?php _e("Email: " , 'srslide'); ?></td>
                <td><input type="text" name="srslide_sr_login" value="<?php echo $srslide_sr_login; ?>" size="35"></td>
                <td><?php _e(" ex: user@example.com" , 'srslide'); ?></td>
              </tr>

              <tr>
                <td class="label"><?php _e("Password: " , 'srslide'); ?></td>
                <td><input type="password" name="srslide_sr_pass" value="<?php echo $srslide_sr_pass; ?>" size="35"></td>
                <td><?php _e(" ex: secretpass" , 'srslide'); ?></td>
              </tr>

              <tr>
                <td>&nbsp;</td>
                <td colspan="2" class="srslide_minitext">
                  <input type="checkbox" name="srslide_show_logo" <?php echo $slide_show_logo; ?> />
                  <?php _e("I would like to display The Slide logo (increases engagement)", 'srslide'); ?>
                </td>
              </tr>

              <tr>
                <td>&nbsp;</td>
                <td style='text-align:right'><input type="submit" name="Submit" value="<?php _e('Register', 'srslide'); ?>" /></td>
                <td>&nbsp;</td>
              </tr>
            </table>

        </form>
	</div>

    <?php 
            }
        } 
    ?>
</div>
